'  August 6, 1995
'
'  Build Conversion Batch for converting CW Clarion File structures using CFIL
'  Note:  Only works on DRIVER('Clarion') files.     
'
'  Written by Bob Sorrells  (71202,1525)
'
'  Disclamer:  This program is only guaranteed to take up disk space. It worked
'              on my files, but it hasn't been tested extensively.
'
'  Input:  Your application name with no period or extension
'
'  Output:  The program produces two files:
'
'           appname.FIL -  This file will contains your application's
'                          file structure, converted to 2.1 format. The
'                          DRIVER('Clarion') statements are stripped out, 
'                          the THREAD, and any line with a "::" is removed.
'                          Any label that is longer than 12 characters is
'                          replaced with a field called NEWFIELD_x.
'
'           convert_.bat - This file contains the batch code that will
'                          call the CFIL.EXE file, referenced the appname.FIL
'                          file.  You can call this from your program by
'                          adding the line RUN('convert_.bat').
'
'
'  QUICKBASIC CODE
'
'  Note:  To make compatible with QBASIC, get rid of the "COMMAND$" stuff
'         and just leave the INPUT "Enter filename...
'

DEFINT A-Z

NewField = 1

CLS
IF COMMAND$ = "" THEN
        INPUT "Enter filename (No Extension) "; infile$
ELSE
        infile$ = COMMAND$
END IF

OPEN "i", #1, infile$ + ".clw"
OPEN "o", #2, infile$ + ".fil"
OPEN "o", #3, "update_.bat"

PRINT #3, "@echo off"

DO WHILE NOT EOF(1)
        LINE INPUT #1, a$
        IF INSTR(a$, "FILE,DRIVER(") <> 0 THEN EXIT DO
        PRINT ".";
LOOP
PRINT

DO
        GOSUB OutputRecord
        IF FileRecordFlag$ = "N" THEN EXIT DO
LOOP

CLOSEALL:
CLOSE
END


OutputRecord:
FileRecordFlag$ = "N"
CwFlag$ = "F"
GOSUB file      ' Strip CW specific stuff
IF CwFlag$ = "F" THEN
        GOSUB SpaceNext
        GOTO HopOut
END IF
PRINT a$
PRINT #2, a$

DO UNTIL EOF(1)               'Pump out the body of the file declaration
        LINE INPUT #1, a$
        a$ = RTRIM$(a$)
        IF a$ = "" THEN
                PRINT a$
                PRINT #2, a$
                EXIT DO
        END IF

        IF INSTR(a$, "::") = 0 THEN
                'Check for too long of a file name
                IF ASC(MID$(a$, 13)) <> 32 THEN ' AND INSTR(LEFT$(a$, 24), ",") = 0 THEN 'AND MID$(a$, 24) = " " AND INSTR(LEFT$(a$, 24), ",") = 0 THEN
                        search$ = RTRIM$(LEFT$(a$, 24))
                        GOSUB remove
                        a$ = LEFT$("NewField_" + LTRIM$(STR$(NewField)) + SPACE$(24), LEN(search$)) + a$
                        NewField = NewField + 1
                END IF
                PRINT a$
                PRINT #2, a$
        END IF


LOOP

FileRecordFlag$ = "Y"
GOSUB HopSpace1
HopOut:
RETURN


file:
search$ = ",DRIVER('Clarion')"  'Get Rid of File
GOSUB remove
IF found$ <> "T" THEN
        CwFlag$ = "F"
ELSE
        CwFlag$ = "T"
        outfile$ = RTRIM$(LEFT$(a$, 20))
        PRINT #3, "echo Processing file "; outfile$; "  Please wait..."
        PRINT #3, "if exist "; outfile$; ".dat cfil "; infile$; ".fil "; outfile$; " /v"
        PRINT #3, "if not exist "; outfile$; ".dat cfil "; infile$; ".fil "; outfile$; " I= /v"
END IF

IF INSTR(a$, "INCLUDE('") <> 0 THEN GOTO CLOSEALL
search$ = ",THREAD"
GOSUB remove
RETURN



remove:
found$ = "F"
temp1 = INSTR(a$, search$)
IF temp1 = 0 THEN GOTO endremove
temp$ = LEFT$(a$, temp1 - 1) + RIGHT$(a$, LEN(a$) - temp1 - LEN(search$) + 1)
a$ = temp$
found$ = "T"
endremove:
RETURN



SpaceNext:
'Go till next space, then go until no more space
DO UNTIL EOF(1)                         'Go till space
        LINE INPUT #1, a$
        a$ = LTRIM$(a$)
        IF a$ = "" THEN GOTO HopSpace1
LOOP
GOTO CLOSEALL

HopSpace1:
DO UNTIL EOF(1)                 'Go till no space
        LINE INPUT #1, a$
        a$ = LTRIM$(a$)
        IF a$ <> "" THEN RETURN
LOOP
GOTO CLOSEALL

