#TEMPLATE(CWBookChapter20,'CW Book Exercises')
#!-------------------------------------------------------------------------
#! (c) Copyright 1995 by David Harms & Ross Santos. 
#!-------------------------------------------------------------------------
#!
#!  Developing Applications with Clarion for Windows
#!
#!  This set of templates includes the following:
#!
#!  Template Type     Name                      Purpose
#!  ----------------- ----------------------    -----------------------------------
#!  Extension         CWBookThreadManagerGlobal Thread Manager map and project additions
#!
#!-------------------------------------------------------------------------
#! Aenderungshistorie:
#!
#! 21.04.95 PH   CWBookTM_CloseAll zugefuegt
#!
#!-------------------------------------------------------------------------
#EXTENSION(CWBookTM_SetupThreadManager,'Thread Manager Map and Project Additions'),APPLICATION
#DISPLAY('')
#DISPLAY('This extension adds the Thread Management DLL and ')
#DISPLAY('its function prototypes to your application. It is')
#DISPLAY('required for all the thread management functions')
#DISPLAY('')
#PROJECT('TM.LIB')
#AT(%GlobalMap)
#IF(%Target32)
MODULE('TM32.LIB')
#ELSE
MODULE('TM16.LIB')
#ENDIF
  TmCreate(LONG,STRING,<STRING>,<USHORT>,<STRING>),LONG
  TmDebug()
  TmDestroy(LONG),LONG
  TmDestroyGroup(<STRING>),LONG
  TmGetHWnd(LONG),USHORT
  TmGetId(STRING,<STRING>,<STRING>),LONG
  TmQuery(*QUEUE,<STRING>,<STRING>,<STRING>),LONG
END
#ENDAT

#AT(%GlobalData)
#!EQUATES---------------------------------------------------------------------
NIL                     EQUATE('')                      !Program Equates
ONE                     EQUATE(1)                       !One value
SPACE                   EQUATE(' ')                     !Space
THIS                    EQUATE(0)                       !Current Window
ZERO                    EQUATE(0)                       !Zero value
EVENT:CloseQuery        EQUATE(402h)                    !Close and Query Event

#!GLOBAL VARIABLES------------------------------------------------------------
gJunk                   STRING(20)                      !Junk variable
gThreadNo               LONG,THREAD                     !Thread Number
QTM                     QUEUE, PRE(QTM)                 !Thread Manager Queue Definition
Id                        LONG                          !  Thread Id
Name                      STRING(30)                    !  User Control Name
Reference                 STRING(80)                    !  User Control Name Reference
HWnd                      USHORT                        !  Windows Window Handle
GroupId                   STRING(80)                    !  Thread Group Id
                        END
#ENDAT

#!--------------------------------------------------------------------------------------------------
#CODE(CWBookTM_ThreadDebugger,'Call the Thread Manager Debugger Window')
TMDebug()

#!-------------------------------------------------------------------------
#EXTENSION(CWBookTM_ManageThread,'Manage this procedure with the Thread Manager'),PROCEDURE
#BOXED('Thread Management')
  #DISPLAY('')
  #DISPLAY('This extension should be used for any procedure')
  #DISPLAY('that either STARTs a Thread Manager-monitored ')
  #DISPLAY('procedure (using the code template by that name)')
  #DISPLAY('or IS a Thread Manager-monitored procedure.')
  #DISPLAY('')
#ENDBOXED
#PROMPT('Auto-closed by Parent:',CHECK),%ClosedByParent,DEFAULT(%False)
#BOXED('Parent Group Name'),Where(%ClosedByParent)
  #DISPLAY('')
  #DISPLAY('Specify a text string that the parent procedure')
  #DISPLAY('can use to identify instances of this procedure.')
  #DISPLAY('This string must also be specified on the parent')
  #DISPLAY('procedure''s extension template in the "Child ')
  #DISPLAY('Group Name field')
  #DISPLAY('')
  #PROMPT('Parent Group Name:',@s40),%ParentGroupName,REQ
#ENDBOXED
#PROMPT('Auto-close Children',CHECK),%CloseChildren,DEFAULT(%False)
#BOXED('Child Group Name'),Where(%CloseChildren)
  #DISPLAY('')
  #DISPLAY('Specify the text string that identifies the ')
  #DISPLAY('instances of child procedures that are to be ')
  #DISPLAY('closed when this procedure closes. This string')
  #DISPLAY('must also be specified on the child procedure''s')
  #DISPLAY('extension template in the "Parent Group Name" field')
  #DISPLAY('')
  #PROMPT('Child Group Name:',@s40),%ChildGroupName,REQ
#ENDBOXED
#!---------- procedure startup ---------------------------------------------------------
#AT(%WindowEventHandling,'OpenWindow')
#IF(%ClosedByParent)
  gThreadNo = TMCreate(THIS{PROP:Thread},'%Procedure','%ProcedureDescription',|
                  THIS{PROP:Handle},'%ParentGroupName')
#ELSE
  gThreadNo = TMCreate(THIS{PROP:Thread},'%Procedure','%ProcedureDescription',|
                  THIS{PROP:Handle})
#ENDIF
#ENDAT
#!---------- iconize/restore ---------------------------------------------------------
#AT(%WindowOtherEventHandling)
CASE EVENT()
OF EVENT:Iconize
  THIS{PROP:Iconize} = TRUE
OF EVENT:Restore
  IF THIS{PROP:Iconize} = TRUE
    THIS{PROP:Iconize} = FALSE
    THIS{PROP:Active}  = TRUE
  ELSE
    THIS{PROP:Active}  = TRUE
  END
  POST(EVENT:Resume)
END
#ENDAT
#!---------- shutdown ---------------------------------------------------------
#AT(%WindowEventHandling,'CloseWindow')
#ENDAT
#AT(%AfterFileClose)
  #IF(%CloseChildren)
gJunk = TMDestroyGroup('%ChildGroupName')
  #ENDIF
gJunk = TMDestroy(THIS{PROP:Thread})               !Destroy the logical Thread
#ENDAT



#!--------------------------------------------------------------------------------------------------
#CODE(CWBookTM_InitiateThread,'Start a Thread under Thread Manager Control')
#DISPLAY('This code template requires the application extension')
#DISPLAY('CWBookThreadManagerGlobal. For this procedure,')
#DISPLAY('specify how many copies of the procedure can be')
#DISPLAY('executed at one time. If the procedure is already ')
#DISPLAY('running and the maximum number of instances is')
#DISPLAY('reached, the Thread Manager will bring the first')
#DISPLAY('copy run to the foreground')
#DISPLAY('')
#PROMPT('Procedure to call:',PROCEDURE),%CalledProcedure
#PROMPT('Thread Stack:',SPIN(@n7,5000,64000,500)),%ThreadStack,DEFAULT(25000)
#PROMPT('Maximum instances:',SPIN(@n2,1,40,1)),%MaxInstances,DEFAULT(1)
FREE(QTM);CLEAR(QTM)                       
gJunk = TmQuery(QTM,'%CalledProcedure')
IF gJunk => %MaxInstances
  GET(QTM,1)                     
  POST(EVENT:Restore,,QTM:Id)    
ELSE                     
  gJunk = START(%CalledProcedure,%ThreadStack)
END                      
FREE(QTM);CLEAR(QTM)
#!--------------------------------------------------------------------------------------------------
#CODE(CWBookTM_MinimizeAll,'Minimize all active windows with icons')
#LOCALDATA
ThreadCounter    BYTE
#ENDLOCALDATA
FREE(QTM);CLEAR(QTM)                            !      Free/Clear Query Thread Manager Queue
ThreadCounter = TmQuery(QTM,,,)                 !      Get thread Count
IF ThreadCounter                                !      If Children Threads exist
   LOOP ThreadCounter = 1 TO RECORDS(QTM)       !        Loop through Query Thread Manager Records
     GET(QTM,ThreadCounter)                     !          Get Next Query Thread Manager Record
     POST(EVENT:Iconize,,QTM:Id)                !          Post ICONIZE Event to Thread
   END                                          !        End Loop through Query Thread Manager Records
END                                             !      En Dif Children Threads exist
FREE(QTM);CLEAR(QTM)                            !      Free/Clear Query Thread Manager Queue
#!--------------------------------------------------------------------------------------------------
#CODE(CWBookTM_MaximizeAll,'Maximize all active windows with icons')
#LOCALDATA
ThreadCounter    BYTE
#ENDLOCALDATA
FREE(QTM);CLEAR(QTM)                            !      Free/Clear Query Thread Manager Queue
ThreadCounter = TmQuery(QTM,,,)                 !      Get thread Count
IF ThreadCounter                                !      If Children Threads exist
   LOOP ThreadCounter = 1 TO RECORDS(QTM)       !        Loop through Query Thread Manager Records
     GET(QTM,ThreadCounter)                     !          Get Next Query Thread Manager Record
     POST(EVENT:Restore,,QTM:Id)                !          Post RESTORE Event to Thread
   END                                          !        End Loop through Query Thread Manager Records
END                                             !      En Dif Children Threads exist
FREE(QTM);CLEAR(QTM)                            !      Free/Clear Query Thread Manager Queue
#!--------------------------------------------------------------------------------------------------
#CODE(CWBookTM_CloseAll,'Close all active windows')
#LOCALDATA
ThreadCounter    BYTE
#ENDLOCALDATA
FREE(QTM);CLEAR(QTM)                            !      Free/Clear Query Thread Manager Queue
ThreadCounter = TmQuery(QTM,,,)                 !      Get thread Count
IF ThreadCounter                                !      If Children Threads exist
   LOOP ThreadCounter = 1 TO RECORDS(QTM)       !        Loop through Query Thread Manager Records
     GET(QTM,ThreadCounter)                     !          Get Next Query Thread Manager Record
     POST(EVENT:CloseWindow,,QTM:Id)            !          Post Close Event to Thread
   END                                          !        End Loop through Query Thread Manager Records
END                                             !      En Dif Children Threads exist
FREE(QTM);CLEAR(QTM)                            !      Free/Clear Query Thread Manager Queue
